<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
  <xsl:strip-space elements="*"/>
  <xsl:template match="/">
    <lyrics>
      <xsl:for-each select="//*/Score">
        <xsl:if test="count(.//Lyrics) &gt; 0">
          <xsl:element name="part">
            <xsl:if test="name">
              <xsl:attribute name="name">
                <xsl:value-of select="name"/>
              </xsl:attribute>
            </xsl:if>
            <xsl:for-each select="Staff">
              <xsl:if test="count(.//Lyrics) &gt; 0">
                <xsl:variable select="@id" name="staffId"/>
                <xsl:element name="staff">
                  <xsl:attribute name="idx">
                    <xsl:value-of select="$staffId"/>
                  </xsl:attribute>
                  <xsl:attribute name="track">
                    <xsl:value-of select="../Part[./Staff/@id=$staffId]/trackName"/>
                  </xsl:attribute>
                  <xsl:if test="count(.//Lyrics) &gt; 0">
                    <xsl:call-template name="GroupLyrics">
                      <xsl:with-param name="tree" select=".//Lyrics"/>
                      <xsl:with-param name="verse-no" select="0"/>
                    </xsl:call-template>
                  </xsl:if>
                </xsl:element>
              </xsl:if>
            </xsl:for-each>
          </xsl:element>
        </xsl:if>
      </xsl:for-each>
    </lyrics>
  </xsl:template>
  <xsl:template name="GroupLyrics">
    <xsl:param name="tree"/>
    <xsl:param name="verse-no"/>
    <xsl:variable name="elts" select="$tree[number(concat('0', no)) = $verse-no]"/>
    <xsl:element name="verse">
      <xsl:attribute name="nr">
        <xsl:value-of select="$verse-no + 1"/>
      </xsl:attribute>
      <xsl:for-each select="$elts">
        <xsl:if test="position() != 1 and not(syllabic='middle' or syllabic='end')">
          <xsl:text> </xsl:text>
        </xsl:if>
        <xsl:value-of select="text"/>
      </xsl:for-each>
    </xsl:element>
    <xsl:if test="count($tree) &gt; count($elts)">
      <xsl:call-template name="GroupLyrics">
        <xsl:with-param name="tree" select="$tree[not(number(concat('0', no)) = $verse-no)]"/>
        <xsl:with-param name="verse-no" select="$verse-no + 1"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
